#pragma once

#include <bitset>

namespace mtb
{

  class CircuitTime
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int circuit_season() const { return circuit_season_; };
    int circuit_time_type() const { return circuit_time_type_; };
    const std::string start_time() const { return start_time_; };
    const std::string end_time() const { return end_time_; };
    int cec_pool() const { return cec_pool_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_circuit_season() const { return __flags__.test(1);};
    bool has_circuit_time_type() const { return __flags__.test(2);};
    bool has_start_time() const { return __flags__.test(3);};
    bool has_end_time() const { return __flags__.test(4);};
    bool has_cec_pool() const { return __flags__.test(5);};

  protected:

    int id_ = 0;
    int circuit_season_ = 0;
    int circuit_time_type_ = 0;
    std::string start_time_;
    std::string end_time_;
    int cec_pool_ = 0;

public:
    std::bitset<6> __flags__;
  };

};
